﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows;
using Infragistics.Controls.Menus;

namespace DataTree_Grid_DragDrop
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public class Person
        {
            public string Name { get; set; }
            public int Age { get; set; }
            public double Salary { get; set; }
        }

        public MainWindow()
        {
            InitializeComponent();

            ObservableCollection<Person> data1 = new ObservableCollection<Person>();
            data1.Add(new Person() { Name = "Jim", Age = 23, Salary = 1200 });
            data1.Add(new Person() { Name = "Tim", Age = 27, Salary = 1400 });
            data1.Add(new Person() { Name = "Pim", Age = 31, Salary = 1100 });
            data1.Add(new Person() { Name = "Kim", Age = 22, Salary = 1500 });
            data1.Add(new Person() { Name = "Gimly", Age = 325, Salary = 100000 });

            xamDataGrid1.DataSource = data1;

            ObservableCollection<Person> data2 = new ObservableCollection<Person>();
            data2.Add(new Person() { Name = "John", Age = 25, Salary = 1000 });
            data2.Add(new Person() { Name = "Simon", Age = 12, Salary = 0 });
            data2.Add(new Person() { Name = "Byron", Age = 41, Salary = 2000 });
            data2.Add(new Person() { Name = "Ilarion", Age = 52, Salary = 3000 });

            xamDataTree1.ItemsSource = data2;
        }

        private void DragSource_Drop(object sender, Infragistics.DragDrop.DropEventArgs e)
        {
            CellValuePresenter cvp = Utilities.GetDescendantFromType(((Infragistics.DragDrop.DragSource)(sender)).AssociatedObject, typeof(CellValuePresenter), false) as CellValuePresenter;
            if (cvp != null)
            {
                if (e.DropTarget == xamDataTree1)
                {
                    if (cvp.DataPresenter == xamDataGrid1)
                    {
                        (xamDataTree1.ItemsSource as ObservableCollection<Person>).Add(cvp.Record.DataItem as Person);
                        (xamDataGrid1.DataSource as ObservableCollection<Person>).Remove(cvp.Record.DataItem as Person);
                        return ;
                    }
                }
            }

            StackPanel dataTreeNode = ((Infragistics.DragDrop.DragSource)(sender)).AssociatedObject as StackPanel;

            if (dataTreeNode != null)
            {
                if (e.DropTarget == xamDataGrid1)
                {
                    (xamDataGrid1.DataSource as ObservableCollection<Person>).Add((dataTreeNode.DataContext as XamDataTreeNodeDataContext).Data as Person);
                    (xamDataTree1.ItemsSource as ObservableCollection<Person>).Remove((dataTreeNode.DataContext as XamDataTreeNodeDataContext).Data as Person);
                }
            }

        }
    }
}
